
$(function(){
  $('input.reveal').click(function(event) {
    const inc_reveal_opt_ele = event.target; //iro_ele
    if(inc_reveal_opt_ele.getAttribute("name").indexOf("inclReveal") > -1){
      let include_reveal;
      if(inc_reveal_opt_ele.value == "yes"){
        include_reveal = true;
      }else if(inc_reveal_opt_ele.value == "no"){
        include_reveal = false;
      }
      let re_fgh_div;
      const par_iro_ele = inc_reveal_opt_ele.parentElement;
      if(par_iro_ele){
        const par_iroLable_ele = par_iro_ele.parentElement;
        if(par_iroLable_ele){
          re_fgh_div = par_iroLable_ele.parentElement;
        }
      }
      if(re_fgh_div){
        //get the children of the re_fgh_div
        const re_fgh_div_childs = re_fgh_div.children;
        let re_reveal_type;
        let re_reveal_text;
        let i;
        for(i=0;i<re_fgh_div_childs.length;i++){
          if(re_fgh_div_childs[i].getAttribute("name")=="reveal-type"){
            re_reveal_type = re_fgh_div_childs[i];
          }else if(re_fgh_div_childs[i].getAttribute("name")=="reveal-text"){
            re_reveal_text = re_fgh_div_childs[i];
          }
        }
        if(include_reveal){
          re_reveal_type.style.removeProperty('display');
          re_reveal_text.style.removeProperty('display');
        }else{
          re_reveal_type.style.display='none';
          re_reveal_text.style.display='none';
        }
      }
    }
  });
  $('input.quest-type').click(function(event) {
    const q_type_opt_ele =  event.target; //qto_ele
    if(q_type_opt_ele.getAttribute("name").indexOf("queType") > -1){
      let q_type = q_type_opt_ele.value;
      let re_fgh_div;
      const par_qto_ele = q_type_opt_ele.parentElement;
      if(par_qto_ele){
        const par_qtoLable_ele = par_qto_ele.parentElement;
        if(par_qtoLable_ele){
          re_fgh_div = par_qtoLable_ele.parentElement;
        }
      }
      if(re_fgh_div){
        const question_num = re_fgh_div.getAttribute("data-question-num");
        //find the div form-check that has the name "question-answer"
        const quest_opts_div = SearchChildrenFor([['tagName',"DIV"],['class','form-check'],['name','question-answer']],re_fgh_div);
        const quest_rnd_div = SearchChildrenFor([['tagName',"DIV"],['class','form-check'],['name','question-random']],re_fgh_div);
        if(quest_opts_div){
          const quest_opts_div_childs = quest_opts_div.children;
          //for each input that's do stuff to the radio
          let i;
          for(i=0;i<quest_opts_div_childs.length;i++){
            //get question input element
            const input_id = "q"+question_num+"optionText"+i;
            const quest_input = SearchChildrenFor([['tagName',"INPUT"],['id',input_id],['type','text']],re_fgh_div);
            //get the whole form input which includes the label and the input, find the parent of the input ele
            const form_group_row_par = quest_input.parentElement;
            if(quest_opts_div_childs[i].classList.contains('gen-label')){
              const input_childs = quest_opts_div_childs[i].children;
              //reset to default
              clear_all_invalid();
              if(quest_opts_div_childs[i].style.display == "none"){
                quest_opts_div_childs[i].style.removeProperty("display");
              }
              //do stuff to the question options input
              if(quest_input){
                if(quest_input.disabled == true){
                  quest_input.removeAttribute("disabled");;
                }
                if(quest_input.style.display = "none"){
                  quest_input.style.removeProperty("display");
                }
                if(quest_input.value == "True" || quest_input.value == "False"){
                  quest_input.value = "";
                }
                //check to see if the whole question input form group is hidden
                if(form_group_row_par && ((form_group_row_par.className).trim()).includes("form-group row")){
                  if (form_group_row_par.style.display =="none"){
                    form_group_row_par.style.removeProperty("display");
                  }
                }
              }
              //reset the options div if hidden
              if(quest_opts_div.style.display =="none"){
                quest_opts_div.style.removeProperty("display");
              }
              //reset the randomize div if hidden
              if(quest_rnd_div && quest_rnd_div.style.display =="none"){
                quest_rnd_div.style.removeProperty("display");
              }
              let j;
              for(j=0; j<input_childs.length;j++){
                if(input_childs[j].getAttribute("name").indexOf("optionValue")> -1){
                  //reset options to default
                  if(input_childs[j].checked == true){
                    input_childs[j].checked = false;
                  }

                  if(input_childs[j].style.display == "none"){
                    input_childs[j].style.removeProperty("display");
                  }
                  if(quest_opts_div_childs[i].style.display == "none"){
                    quest_opts_div_childs[i].style.removeProperty("display");
                  }
                  if(input_childs[j].disabled == true){
                    input_childs[j].removeAttribute("disabled");
                  }
                  //work on the options based on selection
                  if(q_type == "ms"){ //convert to checkbox
                    input_childs[j].setAttribute("type","checkbox");
                  }else if(q_type == "mc" || q_type == "tf" || q_type == "sa" || q_type == "ra"){ //convert back to radio
                    input_childs[j].setAttribute("type","radio");
                    if(q_type == "tf"){ // set tf text and disable all except for options 1 and 2
                      if(quest_input){
                        if(i == 1){
                          quest_input.value = "True";
                        }else if(i == 2){
                          quest_input.value = "False";
                        }else if(i > 2){
                          input_childs[j].disabled = true;
                          quest_opts_div_childs[i].style.display = "none";
                          input_childs[j].style.display = "none";
                          quest_input.value = "";
                          if(form_group_row_par && ((form_group_row_par.className).trim()).includes("form-group row")){
                            form_group_row_par.style.display = "none";
                          }
                          quest_input.disabled = true;
                        }
                      }
                    }else if(q_type == "sa" || q_type == "ra"){
                      if(q_type == "sa"){
                        //hide & disable the options input
                        quest_input.value = "";
                        quest_input.disabled = true;
                        quest_input.style.display = "none";
                        if(form_group_row_par && ((form_group_row_par.className).trim()).includes("form-group row")){
                          form_group_row_par.style.display = "none";
                        }
                      }
                      //hide & disable correct options radio for both sa and ra
                      input_childs[j].disabled = true;
                      quest_opts_div_childs[i].style.display = "none";
                      input_childs[j].style.display = "none";
                    }
                  }
                  break;
                }
              }
            }
          }
          if(q_type == "sa" || q_type == "ra"){
            //hide & disable correct options div
            quest_opts_div.style.display = "none";
          }
          if(q_type == "sa" || q_type == "tf" || q_type == "ra"){
            //hide & disable randomize options
            if(quest_rnd_div){
              quest_rnd_div.style.display = "none";
            }
          }
        }
      }
    }
  });
});
