(function(){
    try{
        addEditAble();
    }catch(err){
    }
    try{
        removeOnEdit();
    }catch(err){
    }
    try{
        cameraReadyOn();
    }catch(err){
    }
    try{
        clearHintStyle();
    }catch(err){
    }
    try{
        accordNoShow(); //used for old quiz hints, old quiz collapsable panels, and mulTargs [Tabs and Accords built now]
    }catch(err){
    }
    try{
        wrapYTubeVids();
    }catch(err){
    }
    try{
        removeCusActivityAttr();
    }catch(err){
    }
})();

//make videos in collapsible or tab responsive for youtube videos
/*Do the following
*Find all iframe elements with title="YouTube video player"
*
*check closest parent to see if its in a tab, accordion or hin-answer using the class advAccord in div
*delete the p style if exist
*repackage in the resposive div
*/
function wrapYTubeVids(){
    let i;
    // let listOfEle = document.querySelectorAll("iframe[title='YouTube video player']");
    let listOfEle = document.querySelectorAll("iframe[allowfullscreen]");
    let offsetEle;
    let responsEle;
    for (i = 0; i < listOfEle.length; i++) {
        //check for for parent node and see if p style element
        const iframeNode=listOfEle[i];
        if (iframeNode.getAttribute("src").indexOf("youtube.com")>0 && iframeNode.getAttribute("src").indexOf("/embed")>0){
            const iframeStyleNode = iframeNode.parentNode;
            let pNodeStyle;
            const divContentHolder = iframeStyleNode.parentNode; //div with no attribute the holds the content within the tab/accord body
            const divTabAccBodyNode = divContentHolder.parentNode;
            if(iframeStyleNode.nodeName == "P" || iframeStyleNode.nodeName == "DIV"){ //also if it's a TD then there should only be just the video and need to wrap it.
                pNodeStyle=iframeStyleNode.getAttribute("style");
                if((divTabAccBodyNode.nodeName == "DIV" && (divTabAccBodyNode.classList.contains("hint-answer")==true || divTabAccBodyNode.classList.contains("advAcc-body")==true || divTabAccBodyNode.classList.contains("advTab-body")==true || divTabAccBodyNode.classList.contains("advTab")==true)) || (iframeStyleNode.classList.contains("hint-answer")==true || iframeStyleNode.classList.contains("advAcc-body")==true || iframeStyleNode.classList.contains("advTab-body")==true || iframeStyleNode.classList.contains("advTab")==true)){ //in the an advAccord
                    offsetEle = document.createElement("DIV");
                    responsEle = document.createElement("DIV");
                    responsEle.className="embed-responsive embed-responsive-16by9";
                    if(pNodeStyle != null && pNodeStyle.indexOf("text-align")>=0 && pNodeStyle.indexOf("center")>0){
                        offsetEle.className="col-md-8 offset-md-2";
                        responsEle.style.maxWidth ="600px";
                        responsEle.appendChild(iframeNode);
                        offsetEle.appendChild(responsEle);
                        divContentHolder.insertBefore(offsetEle,iframeStyleNode);
                    }else if(pNodeStyle != null && pNodeStyle.indexOf("text-align")>=0 && pNodeStyle.indexOf("justify")>0){
                        responsEle.appendChild(iframeNode);
                        divContentHolder.insertBefore(responsEle,iframeStyleNode);
                    }else if(pNodeStyle != null && pNodeStyle.indexOf("text-align")>=0 && pNodeStyle.indexOf("right")>0){
                        responsEle.style.maxWidth ="600px";
                        responsEle.style.float = "right";
                        responsEle.appendChild(iframeNode);
                        divContentHolder.insertBefore(responsEle,iframeStyleNode);
                    }else if(pNodeStyle != null && pNodeStyle.indexOf("text-align")>=0 && pNodeStyle.indexOf("left")>0){
                        responsEle.style.maxWidth ="600px";
                        responsEle.style.float = "left";
                        responsEle.style.marginRight="20px";
                        responsEle.appendChild(iframeNode);
                        divContentHolder.insertBefore(responsEle,iframeStyleNode);
                    }else{
                        responsEle.style.maxWidth ="600px";
                        responsEle.appendChild(iframeNode);
                        if(iframeStyleNode.nodeName == "DIV"){
                            iframeStyleNode.appendChild(responsEle);
                        }else{
                            divContentHolder.insertBefore(responsEle,iframeStyleNode);
                        }
                    }
                    if(iframeStyleNode.nodeName == "P"){
                        iframeStyleNode.remove();
                    }
                }
            }
        }
        
    }
}

//Add the edit-able class for any contenteditable=true attribute that was missed
function addEditAble(){
    let i;
    //add up the edit-able class if missing from any contenteditable=true attribute
    let listOfEle = document.querySelectorAll("div[contenteditable='true']");
    for (i = 0; i < listOfEle.length; i++) {
        //add edit-able if not present
        if(listOfEle[i].classList.contains("edit-able")==false){
            listOfEle[i].classList.add("edit-able")
        }
    }
}

//Clean quiz when edit off?have text boxes for mods?
function cameraReadyOn(){
    let i;
    let listOfEle;
    //Clean up the editable fields
    listOfEle = document.getElementsByClassName("edit-able");
    while(listOfEle.length>0){
        listOfEle[0].removeAttribute("style");
        listOfEle[0].removeAttribute("contenteditable");
        listOfEle[0].classList.remove("edit-able");
    }

    //make the collapsible panel clickable to open by add the attributes needed
    listOfEle = document.getElementsByClassName("edit-accord-title");
    let uniqueID = '';
    let ariaCVal = '';
    for (i = 0; i < listOfEle.length; i++) {
        //need to get the aria-controls value, parse the collapse part out to get thus unique name afterQ
        ariaCVal = listOfEle[i].getAttribute("aria-controls");
        uniqueID = ariaCVal.substring(8);
        //listOfEle[i].setAttribute("data-parent", "#accordion"+uniqueID);
        listOfEle[i].setAttribute("data-target", "#collapse"+uniqueID);
        
    }

    //make tabs clickable and then add the attributes needed
    listOfEle = document.getElementsByClassName("edit-tab-title");
    let uniqueIDTab = '';
    let ariaCValTab = '';
    for (i = 0; i < listOfEle.length; i++) {
        //need to get the aria-controls value, parse the collapse part out to get thus unique name afterQ
        ariaCValTab = listOfEle[i].getAttribute("aria-controls");
        uniqueIDTab = ariaCValTab.substring(4);
        listOfEle[i].setAttribute("href", "#nav-"+uniqueIDTab);
        listOfEle[i].setAttribute("id", "#nav-"+uniqueIDTab+"-tab");
    }

    //check all buttons and clickables to the pointer
    listOfEle = document.getElementsByClassName("set-as-pointer");
    for (i = 0; i < listOfEle.length; i++) {
        listOfEle[i].style.cursor = "pointer";
    }
}

//take out any elements that have the class "only on edit"
function removeOnEdit(){
    //Clean up the editable fields
    let listOfEle = document.getElementsByClassName("only-on-edit");
    //let numOfEle = listOfEle.length; //need to capture the number of elements since the remove will make the take away as removed
    while(listOfEle.length > 0){
        listOfEle[0].remove();
        if (listOfEle.length > 0){
        }
    }
}

//take out title and contenteditable attributes from any customActivity class div
function removeCusActivityAttr(){
    let listOfEle = document.getElementsByClassName("CustomActivity");
    for(let ele of listOfEle){
        ele.removeAttribute("title");
        ele.removeAttribute("contenteditable");
    }
}

//clear all the styles from hint boxes to take on the edit off mode styles
function clearHintStyle(){
    let listOfEle = document.getElementsByClassName("hint-answer");
    let i;
    for (i = 0; i < listOfEle.length; i++) {
        listOfEle[i].removeAttribute("style")
    }
}



/** used for old quiz hints, old quiz collapsable panels, and mulTargs
 * triggered by advAccord class. 
 * Use deShow to have a default show on an accordion or panel
**/
function accordNoShow(){
    let listOfEle = document.getElementsByClassName("advAccord");
    let i, j, cNames;
    for (i = 0; i < listOfEle.length; i++) {
        //listOfEle[i].classList.toggle("show");
        cNames = listOfEle[i].className.split(" ");
        let cNamesNew="";
        let deShowExist = false;
        if (cNames.length>0 && cNames.indexOf("deShow") > 0){
            deShowExist = true;
        }
        for (j = 0; j < cNames.length; j++){
            if (cNames[j] != "show"){
            cNamesNew += cNames[j];
            }else{
            if (deShowExist == true){ //add the show class to accordian after out of edit mode
                cNamesNew += "show";
            }
            }
            if ((cNames.length-j) > 1 ){ //add space if not the last one
            cNamesNew += " ";
            }
        }
        listOfEle[i].className = cNamesNew;
    }
}