try{
    const listOfEle_Tabs = document.getElementsByClassName(parentCActivity_class_Tabs);
    if (listOfEle_Tabs.length>0){
        let i;
        for(i=0; i<listOfEle_Tabs.length; i++){
            if (listOfEle_Tabs[i].getAttribute('title') == parentCActivity_title_Tabs){
                const re_CompInfo_obj = new CompInfoObject(listOfEle_Tabs[i],builder_class_Tabs);
                
                // Build the static container piece, instructions found at staticParts_Tabs[0]
                const re_instruct_ob_S_0 = new InstructObject(staticParts_Tabs[0]);
                re_instruct_ob_S_0.areObjects_RIA = true;
                // Build the info array for the instructions to create each flip card dynamicParts_Tabs[0]
                const re_instruct_ob_D_0 = new InstructObject(dynamicParts_Tabs[0]);
                const re_instruct_ob_D_1 = new InstructObject(dynamicParts_Tabs[1]);
                const result_of_info_build = Build_Info_Array(re_CompInfo_obj,re_instruct_ob_D_0,buildtBody_class_Tabs,info_col_def_Tabs);
                if(result_of_info_build){
                    re_instruct_ob_S_0.settings_arr.set('activity-id',re_CompInfo_obj.activity_ID);
                    Customize_Info_Tabs(re_instruct_ob_D_0);
                    re_instruct_ob_D_1.row_info_arrays = re_instruct_ob_D_0.row_info_arrays.slice();
                    //use the same information array for D_1
                    re_instruct_ob_S_0.row_info_arrays.push(re_instruct_ob_D_0);
                    re_instruct_ob_S_0.row_info_arrays.push(re_instruct_ob_D_1);
                    //INO type see if need to apply any settings
                    re_CompInfo_obj.instructions_array.push(re_instruct_ob_S_0);
                    const built_html = Build_HTML(re_CompInfo_obj);
                    if(built_html && built_html.children.length>0){
                        insert_before(re_CompInfo_obj.parCActivityDIV_element,re_CompInfo_obj.buiDIV_element,built_html);
                    }
                }
            }
        }
    }     
}catch(err){
}

/**
 * Go through the info array in the instruction object and add custom classes or column value based on the components needs. ex. generate IDs if needed
 * @param {Object} instruct_obj 
 */
 function Customize_Info_Tabs(instruct_obj){
    //need to set the last col 4 & 5 to have show and active for the first tab
    if(instruct_obj.getIA_Size()){
        for(let i=0; i<instruct_obj.getIA_Size(); i++){
            const divContent_show = document.createElement("DIV");
            const divContent_active = document.createElement("DIV");
            if(i==0){//set first tab as active
                const textNode_show = document.createTextNode("show");
                const textNode_active = document.createTextNode("active");
                divContent_show.append(textNode_show);
                divContent_active.append(textNode_active);
                instruct_obj.get_row_At(i).push(divContent_show);
                instruct_obj.get_row_At(i).push(divContent_active);

            }else{
                instruct_obj.get_row_At(i).push(divContent_show);
                instruct_obj.get_row_At(i).push(divContent_active);
            }
        }
    }
    Set_Empty_toIndexVal_ColAt(instruct_obj,[1,2]);
}